/*
 * Ring : Ala Ping but for special purposes... to communicate with icmpd !
 *         You need to have an icmpd running at the remote site ofcourse..
 *         You also need netcat and root permissions.
 * 
 * Some code is cut & paste from neptune.c (greetz to route)
 * 
 * YinYang 
 * rene@via.nl
 * 
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <syslog.h>
#include <pwd.h>
#include <unistd.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>
#include <sys/socket.h>
#include <sys/ioctl.h>
#include <fcntl.h>
#include <time.h>
#include <sys/wait.h>
#include <linux/signal.h>
#include <linux/ip.h>
#include <linux/tcp.h>
#include <linux/icmp.h>
#include <signal.h>


#define AMOUNT 2 /* The postman always rings twice */
#define MAXPAK 4096
#define ICMPSLEEP 100


/*
 *	IP Family checksum routine (from UNP)
 */
unsigned short in_cksum(unsigned short *ptr,int nbytes){

	register long           sum;            /* assumes long == 32 bits */
        u_short                 oddbyte;
        register u_short        answer;         /* assumes u_short == 16 bits */
 
        /*
         * Our algorithm is simple, using a 32-bit accumulator (sum),
         * we add sequential 16-bit words to it, and at the end, fold back
         * all the carry bits from the top 16 bits into the lower 16 bits.
         */
 
        sum = 0;
        while (nbytes > 1)  {
                sum += *ptr++;
                nbytes -= 2;
        }
 
                                /* mop up an odd byte, if necessary */
        if (nbytes == 1) {
                oddbyte = 0;            /* make sure top half is zero */
                *((u_char *) &oddbyte) = *(u_char *)ptr;   /* one byte only */
                sum += oddbyte;
        }
 
        /*
         * Add back carry outs from top 16 bits to low 16 bits.
         */
 
        sum  = (sum >> 16) + (sum & 0xffff);    /* add high-16 to low-16 */
        sum += (sum >> 16);                     /* add carry */
        answer = ~sum;          /* ones-complement, then truncate to 16 bits */
        return(answer);
}

/*
 *	Converts IP addresses
 */
unsigned nameResolve(char *hostname){

	struct in_addr addr;
   	struct hostent *hostEnt;

   	if((addr.s_addr=inet_addr(hostname))==-1){
     		if(!(hostEnt=gethostbyname(hostname))){
         		fprintf(stderr,"Name lookup failure: `%s`\n",hostname);
         		exit(0);
      		}
      		bcopy(hostEnt->h_addr,(char *)&addr.s_addr,hostEnt->h_length);
   	}
   	return addr.s_addr;
}



int main(int argc, char ** argv)
{

	unsigned nameResolve(char *);
	
	register int retcode,j=0,sock;
	struct icmphdr *icmp;
	struct sockaddr_in sin,ours;
	unsigned char sendICMPpak[MAXPAK]={0};
	unsigned short id;
	unsigned short port;

	struct ippkt{
   		struct iphdr ip;
   		struct icmphdr icmp;
   		char buffer[MAXPAK];
	}pkt;
	
	if (argc != 5) {
		printf("usage : ring [remotehostname] [icmp id (0xNNNN) ] [localip] [localport]\n");
		exit(1);
	}
	
	if (sscanf(argv[2],"0x%4x",&id) != 1) {
		printf("0xdead or something like that\n");
		exit(1);
	}
	
	ours.sin_addr.s_addr = inet_addr(argv[3]);
	port = (unsigned short) atoi(argv[4]);
	
	sock = socket(AF_INET,SOCK_RAW,IPPROTO_ICMP);
	if (sock < 0) {
		printf("get root...\n");
		exit(1);
	}
	
	bzero((char *)&sin,sizeof(sin));
	sin.sin_family=AF_INET;
	sin.sin_addr.s_addr=nameResolve(argv[1]);

	icmp=(struct icmphdr *)sendICMPpak;

	memcpy(&sendICMPpak[16],&ours.sin_addr.s_addr,4);
	memcpy(&sendICMPpak[20],&port,2);
	
	icmp->type=ICMP_ECHO;			/* Requesting an Echo */
	icmp->code=0;				/* 0 for ICMP ECHO/ECHO_REPLY */
	icmp->un.echo.id=id;			/* Our login identifer */	
	icmp->un.echo.sequence=0;		/* Not used for us */
	icmp->checksum=in_cksum((unsigned short *)icmp,64);

	fprintf(stderr,"ringing %s with id 0x%4x  ",argv[1],id);
	for(;j<AMOUNT;j++){
		usleep(ICMPSLEEP);		/* For good measure */
		retcode=sendto(sock,sendICMPpak,64,0,(struct sockaddr *)&sin,sizeof(sin));
		if(retcode<0||retcode!=64)
			if(retcode<0){
				perror("ICMP sendto err");
				exit(1);
			}
			else fprintf(stderr,"Only wrote %d bytes",retcode);
		else fprintf(stderr,".");
	}
	exit(0);
}


